// Generated by EmberScript 0.0.7
var get$ = Ember.get;
Em.onLoad('Ember.Application', function (application) {
  application.initializer({
    name: 'ember-auth.module.rememberable',
    before: 'ember-auth-load',
    initialize: function (container, app) {
      app.register('authModule:rememberable', get$(get$(Em, 'Auth'), 'RememberableAuthModule'), { singleton: true });
      return app.inject('authModule:rememberable', 'auth', 'auth:main');
    }
  });
  return application.initializer({
    name: 'ember-auth.module.rememberable-load',
    after: 'ember-auth-load',
    initialize: function (container, app) {
      return container.lookup('authModule:rememberable');
    }
  });
});// Generated by EmberScript 0.0.7
var get$ = Ember.get;
var set$ = Ember.set;
set$(get$(Em, 'Auth'), 'RememberableAuthModule', Ember.Object.extend({
  init: function () {
    get$(this, 'auth')._config('rememberable', get$(this, '_defaultConfig'));
    null != get$(this, 'config') || set$(this, 'config', get$(this, 'auth')._config('rememberable'));
    this.patch();
    get$(this, 'auth').addHandler('signInSuccess', get$(this, 'remember').bind(this));
    get$(this, 'auth').addHandler('signInError', get$(this, 'forget').bind(this));
    return get$(this, 'auth').addHandler('signOutSuccess', get$(this, 'forget').bind(this));
  },
  _defaultConfig: {
    tokenKey: null,
    period: 14,
    autoRecall: true,
    endPoint: null
  },
  recall: function (opts) {
    var token;
    if (null == opts)
      opts = {};
    if (!get$(get$(this, 'auth'), 'signedIn') && (token = this.retrieveToken())) {
      set$(this, 'fromRecall', true);
      opts.data || (opts.data = {});
      get$(opts, 'data')[get$(get$(this, 'config'), 'tokenKey')] = token;
      if (null != get$(get$(this, 'config'), 'endPoint')) {
        return get$(this, 'auth').signIn(get$(get$(this, 'config'), 'endPoint'), opts);
      } else {
        return get$(this, 'auth').signIn(opts);
      }
    } else {
      return new (get$(get$(Em, 'RSVP'), 'resolve'));
    }
  },
  remember: function (data) {
    var token;
    if (!get$(this, 'fromRecall'))
      this.forget();
    set$(this, 'fromRecall', false);
    if (token = data[get$(get$(this, 'config'), 'tokenKey')])
      if (!(token === this.retrieveToken())) {
        return this.storeToken(token);
      }
  },
  forget: function () {
    return this.removeToken();
  },
  retrieveToken: function () {
    return get$(get$(this, 'auth'), '_session').retrieve('ember-auth-rememberable');
  },
  storeToken: function (token) {
    return get$(get$(this, 'auth'), '_session').store('ember-auth-rememberable', token, { expires: get$(get$(this, 'config'), 'period') });
  },
  removeToken: function () {
    return get$(get$(this, 'auth'), '_session').remove('ember-auth-rememberable');
  },
  patch: function () {
    var self;
    self = this;
    return get$(Em, 'Route').reopen({
      beforeModel: function () {
        return get$(self, 'auth')._ensurePromise(this._super.apply(this, arguments)).then(function () {
          if (!(get$(get$(self, 'config'), 'autoRecall') && !get$(get$(self, 'auth'), 'signedIn')))
            return;
          return self.recall();
        });
      }
    });
  }
}));